<?php

namespace App\Http\Controllers\Auth;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\Login;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Str;

class ApiAuthControllerTest extends Controller
{
    // 
    public function register(Request $request)
    {
        $validator = Validator::make($request->all(), [
                'name' => 'required|string|max:255',
                'email' => 'required|string|email|max:255|unique:users',
                'password' => 'required|string|min:6|confirmed',
            ]);
        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }
        $request['password']=Hash::make($request['password']);
        $request['remember_token'] = Str::random(10);
        $user = User::create($request->toArray());
        $token = $user->createToken('Laravel Password Grant Client')->accessToken;
        $response = ['token' => $token];
        return response($response, 200);
    }
    public function getTotalEmployees($num)
    {
        
          // /echo $num;
            
        // $num++; // add 1;
        /*$len = strlen($num);
    	    for($i=$len; $i< 4; ++$i) {
    	        $num = '0'.$num;
    	    }*/
        //echo $num;
                $inc=$num+1;//count of number of documents
                ///echo $inc.'<br>';
             $num=str_pad($inc, 5, "0", STR_PAD_LEFT);
    
            
        return $num;
    }
    
    public function getorderByrefrence()
    {
        $refrence_id = $_POST['refrence_id'];
        if ($refrence_id!="") {
                
                //$storeData = DB::table('requests')->where('requests.co_id',$refrence_id)->get();
                
            $ordersData = DB::table('requests')->leftjoin('wilaya', 'wilaya.id', '=', 'requests.r_wallayah')->leftjoin('regions', 'regions.re_id', '=', 'requests.r_region_id')->join('pre_invoice_map', 'pre_invoice_map.actual_id', '=', 'requests.r_id')->join('login', 'login.s_username', '=', 'requests.store_id')->where('requests.co_id', $refrence_id)->get();
            $response = array('message'=>'refrence id','data'=>$ordersData);
        } else {
            $response = array('message'=>'refrence id','data'=>'');
        }
    
        echo json_encode($response);
    }
    
    public function verifyDalileeCustomer(Request $request)
    {

        //$this->check_token($request);
        if (isset($request['phone_no']) && $request['phone_no']!='') {
            $oData = DB::table('requests')->select('requests.*')->where('r_phone', $request['phone_no'])->first();

            if (!empty($oData)) {
                $csData['phone'] = $oData->r_phone;
                $csData['name'] = $oData->r_name;
                $csData['region'] = $oData->r_region_id;
                $csData['wilaya'] = $oData->r_wallayah;
            } else {
                $csData['phone'] = '';
                $csData['name'] = '';
                $csData['region'] = '';
                $csData['wilaya'] = '';
            }



            $response = array('code'=>1,'message'=>'','data'=>$csData);
            echo  json_encode($response);
            exit;
        } else {
            $response = array('code'=>0,'message'=>'phone no is missing','data'=>'');
            echo  json_encode($response);
            exit;
        }
    }
    
        public function cancel_order()
    {
        $dalieeorderid = $_POST['order_id'];
        $storecode = $_POST['store_code'];

       if($dalieeorderid!=""){

        if($storecode !=""){

                 $r = (int) $dalieeorderid;
                $oData = DB::table('login')->select('login.*')->where('store_code',$storecode)->first();
         
                $store_username = $oData['s_username'];


            if($r){

                if ($r !="") {

                    $oData = DB::table('requests')->select('requests.*')->where('r_id',$r)->where('store_id',$store_username)->first();
                    if(!empty($oData)){

                            if($oData['rsid'] !=""){

                                $response = array('code'=>0,'message'=>'Order already Processed','data'=>'');
                                echo  json_encode($response);
                                exit;


                            }
                            else{

                                DB::table('requests')->where('r_id', $dalieeorderid)->update(['r_status'=>0]);

                            }

                    }
                    else{

                         $response = array('code'=>0,'message'=>'Order does not Exist','data'=>'');
                         echo  json_encode($response);
                          exit;

                    }
                    

                }
                else{

                    $oData = DB::table('requests')->select('requests.*')->where('r_id',$dalieeorderid)->first();
                    DB::table('requests')->where('r_id', $dalieeorderid)->update(['r_status'=>0]);


                }



            }
            else{

                $response = array('code'=>0,'message'=>'Order id required ','data'=>'');
                echo  json_encode($response);
                exit;
            }




        }
        else{

            $response = array('code'=>0,'message'=>'Store code is  required ','data'=>'');
                echo  json_encode($response);
                exit;

        }

                 
 

       

       }
       else{


                $response = array('code'=>0,'message'=>'parameter is missing','data'=>'');
             echo  json_encode($response);
                exit; 
        
       } 
        
    }
    public function cancel_order2()
    {
        $dalieeorderid = $_POST['order_id'];
        if ($dalieeorderid !="") {
            DB::table('requests')->where('r_id', $dalieeorderid)->update(['r_status'=>0]);
        }
    }
    public function getOrderData()
    {
        $order_id = $_POST['order_id'];
        if ($order_id!="") {
                
                //$storeData = DB::table('requests')->where('requests.co_id',$refrence_id)->get();
                
            /*$ordersData = DB::table('requests')->leftjoin('wilaya', 'wilaya.id', '=', 'requests.r_wallayah')->leftjoin('regions', 'regions.re_id', '=', 'requests.r_region_id')->join('pre_invoice_map', 'pre_invoice_map.actual_id', '=', 'requests.r_id')->join('login', 'login.s_username', '=', 'requests.store_id')->where('requests.co_id',$refrence_id)->get();*/
                
            $ordersData =DB::table('requests')->select([
      'requests.r_id','requests.r_id','requests.r_name','requests.r_phone','requests.r_ship_price','requests.r_price','requests.store_id','requests.r_date','requests.r_date','requests.r_status','regions.re_name as regionname','wilaya.name_en as wilayaname','requests.r_d_date','requests.r_time'
  ])->leftjoin('login', 'login.s_username', '=', 'requests.store_id')->leftjoin('pre_invoice_map', 'pre_invoice_map.actual_id', '=', 'requests.r_id')->leftjoin('wilaya', 'wilaya.id', '=', 'requests.r_wallayah')->leftjoin('regions', 'regions.re_id', '=', 'requests.r_region_id')->where('requests.r_id', $order_id)->first();
            $response = array('message'=>'refrence id','data'=>$ordersData);
        } else {
            $response = array('message'=>'refrence id','data'=>'');
        }
    
        echo json_encode($response);
    }
    
    public function getOrderLog(Request $request)
    {
    
        //     print_r($_POST);
        // exit;
        if ($_POST['order_no'] !="") {
            $format =0;
            $bill_id = $_POST['order_no'];
            if (isset($_POST['format'])) {
                $format = $_POST['format'];
            }
    
            $cURLConnection = curl_init();

            if ($format ==1) {
            //        curl_setopt($cURLConnection, CURLOPT_URL, 'https://dalilee.net/cpdNew/home/viewlogs.php?arr=1&orderno='.$bill_id);
            } else {
          //      curl_setopt($cURLConnection, CURLOPT_URL, 'https://dalilee.net/cpdNew/home/viewlogs.php?orderno='.$bill_id);
            }


            // https://dalilee.net/cpdNew/home/viewlogs.php?arr=0&orderno=A2461335

            curl_setopt($cURLConnection, CURLOPT_URL, 'https://dalilee.net/cpdNew/home/viewlogs.php?arr=1&orderno='.$bill_id);
        
            // curl_setopt($cURLConnection, CURLOPT_URL, 'https://dalilee.net/cpdNew/home/viewlogs.php?arr=1&orderno='.$bill_id);
        
            curl_setopt($cURLConnection, CURLOPT_RETURNTRANSFER, true);

            $logsData = curl_exec($cURLConnection);
            curl_close($cURLConnection);

            //echo $logsData;
            //	$arr = array('data'=>$logsData);

            dd($logsData);
            
            $response = ['data' => $logsData];
            return response($response, 200);
        }
        exit;
    }

    public function getOrderStatus(Request $request)
    {

        
    
        //         print_r($_POST);
        // exit;
        if ($_POST['order_no'] !="") {
            $bill_id = $_POST['order_no'];
            $order_id = substr($bill_id, 1);
                

            $ordersData =DB::table('requests')->select(['requests.r_status as status','requests.operation_status', 'requests.r_status_reason', 'requests.updated_at as status_updated'])->where('requests.r_id', $order_id)->first();
            
            $response = ['data' => $ordersData];
            return response($response, 200);
        }
        exit;
    }

    public function login(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'email' => 'required|string|email|max:255',
            'password' => 'required|string|min:6|confirmed',
        ]);
        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }
        $user = User::where('email', $request->email)->first();
        if ($user) {
            if (Hash::check($request->password, $user->password)) {
                $token = $user->createToken('Laravel Password Grant Client')->accessToken;
                $response = ['token' => $token];
                return response($response, 200);
            } else {
                $response = ["message" => "Password mismatch"];
                return response($response, 422);
            }
        } else {
            $response = ["message" =>'User does not exist'];
            return response($response, 422);
        }
    }
    
    public function viewStoreData()
    {
        $store_id = $_POST['store_number'];
        $storeData = '';
            
        $mrchandata = auth('api')->user();
            
        $mrchandid = $mrchandata['id'];
        if ($store_id !="") {
            $storeData = Login::where('store_code', $request->trader_code)->where('merchant_id', $mrchandid)->first();
        }
                
        /*if($store_id !=""){
                $storeData = DB::table('login')->where('login.s_mobile',$store_id)->first();

        }*/
                
            
        $response = ['data' => $storeData];
        return response($response, 200);
    }
    
    public function calculatePrice()
    {
        $wilaya = $_POST['willaya'];
        $region = $_POST['region'];
        $weight = $_POST['weight'];
        if ($wilaya !="" && $region!="" && $weight!="") {
            $zoneData = DB::table('regions')->join('region_zone_management', 'region_zone_management.region_id', '=', 'regions.re_walayah')->where('regions.re_walayah', $wilaya)->first();
            //echo "<pre>";
            //print_r($zoneData->zone_id);
            //exit;
            $zoneid = $zoneData->zone_id;
            $price_data = DB::table('package_zones')->where('package_id', 1)->where('zone_id', $zoneid)->where('zone_id', $zoneid)->where('doc_type', 0)->where('kg_val', $weight)->first();
            //if()
            unset($price_data->id);
                    
            //print_r($price_data);
            //exit;
            $response = ['data' =>$price_data];
            return response($response, 200);
        } else {
        }
    }
    
    public function calculatePriceUpdated()
    {
        $wilaya = $_POST['willaya'];
        $region = $_POST['region'];
        $weight = $_POST['weight'];
        if ($wilaya !="" && $region!="" && $weight!="") {
            $sql = 'select *,(select CONCAT(packages_settings.package_diff_amount, "-",packages_settings.package_diff_start) from packages_settings where packages_settings.id ="1") as pkgdiff from regions_updated as ru
left join region_zone_management_updated as rzm on rzm.region_id =ru.re_id and rzm.package_id="1"
left join package_zones_updated as pzu on pzu.zone_id=rzm.zone_id and pzu.package_id="1"
where ru.re_id = '.$region.' limit 1 ';
            $results = DB::select(DB::raw($sql));
            $row = $results[0];
            $priceval = $row->price_val;
            $pkgDetail = explode('-', $row->pkgdiff);
            $diff = $pkgDetail[0];
            $start = $pkgDetail[1];
            $price_val = 2;
            if ($start<$weight) {
                $remainingweight=$weight-$start;
                $totla_diff = floatval($remainingweight)*floatval($diff);

                $price_val = $priceval+$totla_diff;
            }

                    
                    
            $price_data['shipping_price'] = $price_val;
            $response = ['data' =>$price_data];
            return response($response, 200);
        } else {
        }
    }

    public function signupTrader(Request $request)
    {

            //   /dd(auth('api')->user());
        //exit;
        $userData = auth('api')->user();
        $validator = Validator::make($request->all(), [
                's_name' => 'required|string|max:255',
                's_username' => 'required|string|max:15|unique:login',
                's_mobile'=>'required|numeric|unique:login',
                's_password' => 'required|string|min:6|confirmed',
                'country_code' => 'required|numeric',
                'region_id' => 'required|numeric',
                'wilaya_id' => 'required|numeric',
                's_email' => 'email',
             ]);

        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }
        //$userData= auth('api')->user();
        //print_r($userData['id']);
        //exit;
        $results = DB::select(DB::raw("SELECT * FROM login where s_type ='store' order by s_id desc limit 1"));
                
        //echo "<pre>";
        //print_r($results[0]->store_code);
        //exit;
                
        if (isset($results[0]->store_code) && $results[0]->store_code!="") {
            $storecode = $results[0]->store_code;
        } else {
            $storecode = "";
        }
               
                
                
        //print_r($results[0]['store_code']);
        //exit;

        //$storecode= $results['store_code'];
        $strc = substr($storecode, 2);
        $number = $this->getTotalEmployees($strc);
        $code = trim('ST'.$number);
                 
        $traders = $request->toArray();
        $traders['s_packageid'] =1;
        $traders['merchant_id'] = $userData['id'];
        $traders['store_code'] =$code;
        $traders['s_type'] ='store';
        unset($traders['region_id']);
        unset($traders['wilaya_id']);
        //echo "<pre>";
        //print_r($traders);
        //exit;
                
        // $login = Login::create($traders);
        // print_r($login);
        // $loginData = $login->fresh();

                
        $response = ['data' =>'success'];
        return response($response, 200);
    }
    public function signupTrader2()
    {
        $validator = Validator::make($request->all(), [
                'name' => 'required|string|max:255',
                'username' => 'required|string|email|max:255|unique:login',
                'password' => 'required|string|min:6|confirmed',
                'country_code' => 'required|numeric',
                'region_id' => 'required|numeric',
                'wilaya_id' => 'required|numeric',
                'email' => 'email',
            ]);

        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }



        $traders = $request->toArray();
        $traders['s_packageid'] =1;

        $login = Login::create($traders);
        $response = ['data' =>$login];
        return response($response, 200);
    }
        
        
    public function addorder2()
    {
        $validator = Validator::make($request->all(), [
                'refrence_id' => 'required|numeric',
                'branchid' => 'required|numeric',
                'qunatity' => 'required|numeric',
                'weight' => 'required',
                'trader_id' => 'required|numeric',
                'region_id' => 'required|numeric',
                'order_date' => 'required',
            ]);
        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }

        $storeData = Login::where('store_code', $request->trader_code)->first();
        $username = $storeData['s_username'];
        $t = date('Y-m-d');
        DB::table('requests')->insert([
                     'store_id'=>$username,
                     'branch_id'=>$request->branchid,
                     'qunatity'=>$request->qunatity,
                     'weight'=>$request->weight,
                     'trader_id'=>$request->trader_id,
                     'region_id'=>$request->region_id,
                     'order_date' =>$t
                   ]);

        $recId = DB::getPdo()->lastInsertId();
            
        $this->getPriceByZone($zoneid, $pacakgeid, $doctype, $weight);
    }
    
    public function addref(Request $request)
    {
        $validator = Validator::make($request->all(), [
                'wilaya_id' => 'required|numeric',
                'region_id' => 'required|numeric',
                'refrence_date' => 'required',
                'collected_cash' => 'required|numeric',
                'quantity' => 'required|numeric',
                'branchid' => 'required|numeric',
                'trader_code'=>'required',
                'notes' => 'string',
            ]);
            
        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }



        //$mrchandid = auth('api')->user();
        $mrchandata = auth('api')->user();
            
        $mrchandid = $mrchandata['id'];
            
        $storeData = Login::where('store_code', $request->trader_code)->where('merchant_id', $mrchandid)->first();
        if (!empty($storeData)) {
            $co_date = $request->refrence_date;
            $username = $storeData['s_username'];
            $hours = date("H:i:s");
            $newdate = $co_date.' '.$hours;
            $t = date('Y-m-d H:i:s', strtotime($newdate));
                
            $cData = DB::table('collection')->insert([
                                     'store_id'=>$username,
                                     'branchid'=>$request->branchid,
                                     'wallayah_id'=>$request->wilaya_id,
                                     'region_id'=>$request->region_id,
                                     'co_quantity'=>$request->quantity,
                                     'co_date'=>$request->refrence_date,
                                     'co_time' => date("h:i:sa"),
                                     'co_up_date_time'=>$t,
                                     'co_notes'=>$request->notesd
                                   ]);
            $recId = DB::getPdo()->lastInsertId();
        } else {
            return response(['errors'=>'Error Store code does not exist'], 422);
        }
            
            


        $collectionData = DB::table('collection')->where('co_id', $recId)->get();

        $response = ['data' => $collectionData];
        return response($response, 200);
    }
    
    
    public function verifyStore(Request $request)
    {
        $validator = Validator::make($request->all(), [
                'trader_code' => 'required'
            ]);
        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }

        $mrchandata = auth('api')->user();
        $mrchandid = $mrchandata['id'];
        $storeData = Login::where('store_code', $request->trader_code)->first();
        if (!empty($storeData)) {
            
                    //$result['s_name'] = $storeData->s_name;
            //$result['s_mobile'] = $storeData->s_mobile;
            //$result['s_username'] = $storeData->s_username;
                
            //echo "<pre>";
            //print_r($storeData);
            //exit;
            $response = ['data' => $storeData];
            return response($response, 200);
        } else {
            return response(['errors'=>'Error Store code does not exist'], 422);
        }
    }
    public function addorder(Request $request)
    {
        $validator = Validator::make($request->all(), [
                'branchid' => 'required|numeric',
                'quantity' => 'required|numeric',
                'weight' => 'required',
                'customer_name'=>'required',
                'customer_number'=>'required',
                'trader_code' => 'required',
                'region_id' => 'required|numeric',
                'order_date' => 'required',
                'doctype'=>'required|numeric',
                'order_price'=>'required|numeric',
                'wallaya_id'=>'required|numeric'
            ]);
        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }
        //'refrence_id' => 'required|numeric',
                    
        //$storeData = Login::where('store_code', $request->trader_code)->first();
        $mrchandata = auth('api')->user();
            
        $mrchandid = $mrchandata['id'];
        $storeData = Login::where('store_code', $request->trader_code)->where('merchant_id', $mrchandid)->first();
            
        $externalno ='';
        if (isset($request->external_way_bill_number)) {
            $externalno =$request->external_way_bill_number;
                
            $sql = 'SELECT r_id FROM `requests`  as r  WHERE r.external_way_bill_number = '.$externalno.'';

            $resultsExt = DB::select(DB::raw($sql));

            if (!empty($resultsExt)) {
                return response(['errors'=>'Error Order already exist'], 422);
            }
        }
            

        if (isset($request->type) && $request->type =='new') {
            $regionID =$request->region_id;
            //$zoneData = DB::table('region_zone_management')->where('region_id',$data['wilaya_id'])->where('is_oman',0)->first();
            $sql = 'select *,(select CONCAT(packages_settings.package_diff_amount, "-",packages_settings.package_diff_start) from packages_settings where packages_settings.id ="1") as pkgdiff from regions_updated as ru
left join region_zone_management_updated as rzm on rzm.region_id =ru.re_id and rzm.package_id="1"
left join package_zones_updated as pzu on pzu.zone_id=rzm.zone_id and pzu.package_id="1"
where ru.re_id = '.$regionID.' limit 1 ';

         

            $results = DB::select(DB::raw($sql));
                    
            if (!empty($results)) {
                $row = $results[0];
                $priceval = $row->price_val;
                //$priceval = $row['price_val'];

                $pkgDetail = explode('-', $row->pkgdiff);
                $diff = $pkgDetail[0];
                $start = $pkgDetail[1];

                $weight = $request->weight;

                if ($start<$weight) {
                    $remainingweight=$weight-$start;
                    $totla_diff = floatval($remainingweight)*floatval($diff);


                    $price_val = $priceval+$totla_diff;

                    //	    echo "<pre>";
          //  print_r($row);
            //exit;
                }
            }
        } else {
            $zoneData = DB::table('region_zone_management')->where('region_id', $data['wilaya_id'])->where('is_oman', 0)->first();

            if (!empty($zoneData)) {
                $zoneid = $zoneData->zone_id;
            } else {
                $zoneid = 1;
            }


            $price_val = $this->getPriceByZone($zoneid, $packageid, $request->doctype, $request->weight);
                
            DB::table('requests')->where('r_id', $recId)->update(array(
                                   'r_ship_price'=>$price_val
                                 ));
        }

        /*$zoneData = DB::connection('mysql2')->table('region_zone_management')->select(['region_zone_management.*'])->where('region_id',$data['wilaya_id'])->where('is_oman',0)->first();*/

                   
        if (!empty($storeData)) {
            //$request->refrence_id
            $packageid = $storeData['s_packageid'];
            $username = $storeData['s_username'];
            $refid = '';
            //$storeid = $storeData['s_id'];
            $d = date('Y-m-d');
            $t = date('H:i:s');
            $regionName ='';
                
            /* $collectionData = DB::table('collection')->where('collection.store_id',$username)->where('collection.co_id',$refid)->first();
             //r_region
             $regionData = DB::table('regions')->where('re_id',$request->region_id)->first();

                 if(!empty($region)){
                     $regionName = $regionData['re_name'];
                 }
                 else{

                     $regionName ='';
                 }
            */

            if (isset($request->type) && $request->type =='new') {
                DB::table('requests')->insert([
                         'store_id'=>$username,
                         'branchid'=>$request->branchid,
                         'r_name'=>$request->customer_name,
                         'r_phone'=>$request->customer_number,
                         'pieces'=>$request->quantity,
                         'weight'=>$request->weight,
                         'wilaya_id'=>$request->wallaya_id,
                         'region_id'=>$request->region_id,
                         'r_region'=>$regionName,
                         'document_type'=>$request->doctype,
                         'r_price'=>$request->order_price,
                         'external_way_bill_number'=>$externalno,
                         'r_date' =>$d,
                         'r_time' =>$t,
                         'r_ship_price'=>2,
                         
                       ]);
            } else {
                DB::table('requests')->insert([
                         'store_id'=>$username,
                         'branchid'=>$request->branchid,
                         'r_name'=>$request->customer_name,
                         'r_phone'=>$request->customer_number,
                         'pieces'=>$request->quantity,
                         'weight'=>$request->weight,
                         'r_wallayah'=>$request->wallaya_id,
                         'r_region_id'=>$request->region_id,
                         'r_region'=>$regionName,
                         'document_type'=>$request->doctype,
                         'r_price'=>$request->order_price,
                         'external_way_bill_number'=>$externalno,
                         'r_date' =>$d,
                         'r_time' =>$t,
                         'r_ship_price'=>0,
                         
                       ]);
            }
                

            if (!empty($collectionData)) {
                                                  
                        
               //        exit;
            }
                    
            
 
                             
            $recId = DB::getPdo()->lastInsertId();
        } else {
            return response(['errors'=>'Error Store code does not exist'], 422);
        }

        //echo "<pre>";
        //print_r($ordersData);
              
        $result = DB::Table('requests')->select('r_id as orderid', 'branchid', 'store_id', 'weight', 'r_name', 'r_phone', 'pieces', 'weight')->where('r_id', $recId)->get();
        $response = ['data' => $result];
        return response($response, 200);
    }
    
    
    
    public function addordernew(Request $request)
    {
        $validator = Validator::make($request->all(), [
                'branchid' => 'required|numeric',
                'quantity' => 'required|numeric',
                'weight' => 'required',
                'customer_name'=>'required',
                'customer_number'=>'required',
                'trader_code' => 'required',
                'order_date' => 'required',
                'doctype'=>'required|numeric',
                'order_price'=>'required|numeric',
                'wallaya_id'=>'required|numeric'
            ]);
        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }
        //'refrence_id' => 'required|numeric',
                    
        //$storeData = Login::where('store_code', $request->trader_code)->first();
        $mrchandata = auth('api')->user();
            
        $mrchandid = $mrchandata['id'];
        $storeData = Login::where('store_code', $request->trader_code)->where('merchant_id', $mrchandid)->first();
            
        $externalno ='';
        if (isset($request->external_way_bill_number)) {
            $externalno =$request->external_way_bill_number;
                
            $sql = 'SELECT r_id FROM `requests`  as r  WHERE r.external_way_bill_number = '.$externalno.'';

            $resultsExt = DB::select(DB::raw($sql));

            if (!empty($resultsExt)) {
                return response(['errors'=>'Error Order already exist'], 422);
            }
        }
            

        
            
             

                   
        if (!empty($storeData)) {
            //$request->refrence_id
            $packageid = $storeData['s_packageid'];
            $username = $storeData['s_username'];
            $refid = '';
            //$storeid = $storeData['s_id'];
            $d = date('Y-m-d');
            $t = date('H:i:s');
            $regionName ='';
                

            DB::table('requests')->insert([
                         'store_id'=>$username,
                         'branchid'=>$request->branchid,
                         'r_name'=>$request->customer_name,
                         'r_phone'=>$request->customer_number,
                         'pieces'=>$request->quantity,
                         'weight'=>$request->weight,
                         'wilaya_id'=>$request->wallaya_id,
                         'region_id'=>0,
                         'r_region'=>'',
                         'document_type'=>$request->doctype,
                         'r_price'=>$request->order_price,
                         'external_way_bill_number'=>$externalno,
                         'r_date' =>$d,
                         'r_time' =>$t,
                         'r_ship_price'=>2,
                         'notes'=>$request->address,
                         
                       ]);
                    
                

                 
                    
            
 
                             
            $recId = DB::getPdo()->lastInsertId();
        } else {
            return response(['errors'=>'Error Store code does not exist'], 422);
        }

        //echo "<pre>";
        //print_r($ordersData);
              
        $result = DB::Table('requests')->select('r_id as orderid', 'branchid', 'store_id', 'weight', 'r_name', 'r_phone', 'pieces', 'weight', 'notes as address')->where('r_id', $recId)->get();
        $response = ['data' => $result];
        return response($response, 200);
    }


    public function addreverseorder(Request $request)
    {
        $validator = Validator::make($request->all(), [
                'quantity' => 'required|numeric',
                'weight' => 'required',
                'customer_name'=>'required',
                'customer_number'=>'required',
                'trader_code' => 'required',
                'order_date' => 'required',
                'order_price'=>'required|numeric',
                'wallaya_id'=>'required|numeric'
                
            ]);
        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }
        //'refrence_id' => 'required|numeric',
                    
        //$storeData = Login::where('store_code', $request->trader_code)->first();
        $mrchandata = auth('api')->user();
            
        $mrchandid = $mrchandata['id'];
        $storeData = Login::where('store_code', $request->trader_code)->where('merchant_id', $mrchandid)->first();
            
        $externalno ='';
        if (isset($request->external_way_bill_number)) {
            $externalno =$request->external_way_bill_number;
                
            $sql = 'SELECT r_id FROM `requests`  as r  WHERE r.external_way_bill_number = '.$externalno.'';

            $resultsExt = DB::select(DB::raw($sql));

            if (!empty($resultsExt)) {
                return response(['errors'=>'Error Order already exist'], 422);
            }
        }
            

        
            
             

        $orignal_id ='0';
        if (!empty($storeData)) {
            //$request->refrence_id
            $packageid = $storeData['s_packageid'];
            $username = $storeData['s_username'];

            if (isset($request->original_order)) {
                $orignal_id = substr($request->original_order, 1);
            }

                
            $refid = '';
            //$storeid = $storeData['s_id'];
            $d = date('Y-m-d');
            $t = date('H:i:s');
                
			//$address = addslashes($request->address);
			$address = str_replace(",", " ",$request->address);
            DB::table('requests')->insert([
                         'store_id'=>$username,
                         'branchid'=>1,
                         'r_name'=>$request->customer_name,
                         'r_phone'=>$request->customer_number,
                         'pieces'=>$request->quantity,
                         'weight'=>$request->weight,
                         'wilaya_id'=>$request->wallaya_id,
                         'region_id'=>0,
                         'r_region'=>'',
                         'document_type'=>0,
                         'r_price'=>$request->order_price,
                         'order_reference'=>$orignal_id,
                         'is_reverse'=>1,
                         'r_date' =>$d,
                         'r_time' =>$t,
                         'r_ship_price'=>1.7,
                         'external_way_bill_number'=>$externalno,
                         'notes'=>'',
                         
                       ]);
                    
                

                 
                    
            
 
                             
            $recId = DB::getPdo()->lastInsertId();
        } else {
            return response(['errors'=>'Error Store code does not exist '.$mrchandid], 422);
        }

        //echo "<pre>";
        //print_r($ordersData);
              
        $result = DB::Table('requests')->select('r_id as orderid', 'branchid', 'store_id', 'weight', 'r_name', 'r_phone', 'pieces', 'weight', 'notes as address')->where('r_id', $recId)->get();
        $response = ['data' => $result];
        return response($response, 200);
    }
    
    public function addordertasheel(Request $request)
    {


        //		        'trader_code' => 'required',

         
        $validator = Validator::make($request->all(), [
                'branchid' => 'required|numeric',
                'quantity' => 'required|numeric',
                'weight' => 'required',
                'customer_name'=>'required',
                'customer_number'=>'required',
                'region_id' => 'required|numeric',
                'order_date' => 'required',
                'doctype'=>'required|numeric',
                'order_price'=>'required|numeric',
                'wallaya_id'=>'required|numeric'
            ]);
        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }
        //'refrence_id' => 'required|numeric',
                    
        //$storeData = Login::where('store_code', $request->trader_code)->first();
        //$mrchandata = auth('api')->user();
            
        //$mrchandid = $mrchandata['id'];
        $storeData = Login::where('store_code', 'ST67528')->first();
        
        
            
        $externalno ='';
        if (isset($request->external_way_bill_number)) {
            $externalno =$request->external_way_bill_number;
        }


        $price_val = 0;
            

        if (isset($request->type) && $request->type =='new') {
            $regionID =$request->region_id;
            //$zoneData = DB::table('region_zone_management')->where('region_id',$data['wilaya_id'])->where('is_oman',0)->first();
            $sql = 'select *,(select CONCAT(packages_settings.package_diff_amount, "-",packages_settings.package_diff_start) from packages_settings where packages_settings.id ="1") as pkgdiff from regions_updated as ru
left join region_zone_management_updated as rzm on rzm.region_id =ru.re_id and rzm.package_id="1"
left join package_zones_updated as pzu on pzu.zone_id=rzm.zone_id and pzu.package_id="1"
where ru.re_id = '.$regionID.' limit 1 ';

         

            $results = DB::select(DB::raw($sql));
                    
            if (!empty($results)) {
                $row = $results[0];
                $priceval = $row->price_val;
                //$priceval = $row['price_val'];

                $pkgDetail = explode('-', $row->pkgdiff);
                $diff = $pkgDetail[0];
                $start = $pkgDetail[1];

                $weight = $request->weight;
            
                         


                if ($start<$weight) {
                    $remainingweight=$weight-$start;
                    $totla_diff = floatval($remainingweight)*floatval($diff);


                    $price_val = $priceval+$totla_diff;

                    //	    echo "<pre>";
          //  print_r($row);
            //exit;
                }
            }
        } else {

                //echo "<pre>";
            // print_r($_POST);
            //  exit;
            
            $zoneData = DB::table('region_zone_management')->where('region_id', $_POST['wallaya_id'])->where('is_oman', 0)->first();

            if (!empty($zoneData)) {
                $zoneid = $zoneData->zone_id;
            } else {
                $zoneid = 1;
            }
                
                    


            $price_val = $this->getPriceByZone($zoneid, 1, $request->doctype, $request->weight);
                
            /*DB::table('requests')->where('r_id',$recId)->update(array(
                   'r_ship_price'=>$price_val
                 ));*/
        }

        /*$zoneData = DB::connection('mysql2')->table('region_zone_management')->select(['region_zone_management.*'])->where('region_id',$data['wilaya_id'])->where('is_oman',0)->first();*/
            

                   
        if (!empty($storeData)) {
            //$request->refrence_id
            $packageid = $storeData['s_packageid'];
            $username = $storeData['s_username'];
            $refid = '';
            //$storeid = $storeData['s_id'];
            $d = date('Y-m-d');
            $t = date('H:i:s');
            $regionName ='';
                
            /* $collectionData = DB::table('collection')->where('collection.store_id',$username)->where('collection.co_id',$refid)->first();
             //r_region
             $regionData = DB::table('regions')->where('re_id',$request->region_id)->first();

                 if(!empty($region)){
                     $regionName = $regionData['re_name'];
                 }
                 else{

                     $regionName ='';
                 }
            */

            if (isset($request->type) && $request->type =='new') {
                DB::table('requests')->insert([
                         'store_id'=>$username,
                         'branchid'=>$request->branchid,
                         'r_name'=>$request->customer_name,
                         'r_phone'=>$request->customer_number,
                         'pieces'=>$request->quantity,
                         'weight'=>$request->weight,
                         'wilaya_id'=>$request->wallaya_id,
                         'region_id'=>$request->region_id,
                         'r_region'=>$regionName,
                         'document_type'=>$request->doctype,
                         'r_price'=>$request->order_price,
                         'external_way_bill_number'=>$externalno,
                         'r_date' =>$d,
                         'r_time' =>$t,
                         'r_ship_price'=>$price_val,
                         
                       ]);
            } else {
                DB::table('requests')->insert([
                         'store_id'=>$username,
                         'branchid'=>$request->branchid,
                         'r_name'=>$request->customer_name,
                         'r_phone'=>$request->customer_number,
                         'pieces'=>$request->quantity,
                         'weight'=>$request->weight,
                         'r_wallayah'=>$request->wallaya_id,
                         'r_region_id'=>$request->region_id,
                         'r_region'=>$regionName,
                         'document_type'=>$request->doctype,
                         'r_price'=>$request->order_price,
                         'external_way_bill_number'=>$externalno,
                         'r_date' =>$d,
                         'r_time' =>$t,
                         'r_ship_price'=>$price_val,
                         
                       ]);
            }
                

            if (!empty($collectionData)) {
                                                  
                        
               //        exit;
            }
                    
            
 
                             
            $recId = DB::getPdo()->lastInsertId();
        } else {
            return response(['errors'=>'Error Store code does not exist'], 422);
        }

        $result = DB::Table('requests')->select('r_id as orderid', 'branchid', 'store_id', 'weight', 'r_name', 'r_phone', 'pieces', 'weight')->where('r_id', $recId)->get();
        $response = ['data' =>'A'.$recId];
        return response($response, 200);
    }
    
    
    public function addorderdalileeswaq(Request $request)
    {


        //		        'trader_code' => 'required',

         
        $validator = Validator::make($request->all(), [
                'branchid' => 'required|numeric',
                'quantity' => 'required|numeric',
                'weight' => 'required',
                'customer_name'=>'required',
                'customer_number'=>'required',
                'region_id' => 'required|numeric',
                'order_date' => 'required',
                'doctype'=>'required|numeric',
                'order_price'=>'required|numeric',
                'wallaya_id'=>'required|numeric'
            ]);
        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }
        //'refrence_id' => 'required|numeric',
                    
        //$storeData = Login::where('store_code', $request->trader_code)->first();
        //$mrchandata = auth('api')->user();
            
        //$mrchandid = $mrchandata['id'];
        $storeData = Login::where('store_code', 'ST67528')->first();
        
        
            
        $externalno ='';
        if (isset($request->external_way_bill_number)) {
            $externalno =$request->external_way_bill_number;
        }


        $price_val = 0;
            

        if (isset($request->type) && $request->type =='new') {
            $regionID =$request->region_id;
            //$zoneData = DB::table('region_zone_management')->where('region_id',$data['wilaya_id'])->where('is_oman',0)->first();
            $sql = 'select *,(select CONCAT(packages_settings.package_diff_amount, "-",packages_settings.package_diff_start) from packages_settings where packages_settings.id ="1") as pkgdiff from regions_updated as ru
left join region_zone_management_updated as rzm on rzm.region_id =ru.re_id and rzm.package_id="1"
left join package_zones_updated as pzu on pzu.zone_id=rzm.zone_id and pzu.package_id="1"
where ru.re_id = '.$regionID.' limit 1 ';

         

            $results = DB::select(DB::raw($sql));
                    
            if (!empty($results)) {
                $row = $results[0];
                $priceval = $row->price_val;
                //$priceval = $row['price_val'];

                $pkgDetail = explode('-', $row->pkgdiff);
                $diff = $pkgDetail[0];
                $start = $pkgDetail[1];

                $weight = $request->weight;
            
                         


                if ($start<$weight) {
                    $remainingweight=$weight-$start;
                    $totla_diff = floatval($remainingweight)*floatval($diff);


                    $price_val = $priceval+$totla_diff;

                    //	    echo "<pre>";
          //  print_r($row);
            //exit;
                }
            }
        } else {

                //echo "<pre>";
            // print_r($_POST);
            //  exit;
            
            $zoneData = DB::table('region_zone_management')->where('region_id', $_POST['wallaya_id'])->where('is_oman', 0)->first();

            if (!empty($zoneData)) {
                $zoneid = $zoneData->zone_id;
            } else {
                $zoneid = 1;
            }
                
                    


            $price_val = $this->getPriceByZone($zoneid, 1, $request->doctype, $request->weight);
                
            /*DB::table('requests')->where('r_id',$recId)->update(array(
                   'r_ship_price'=>$price_val
                 ));*/
        }

        /*$zoneData = DB::connection('mysql2')->table('region_zone_management')->select(['region_zone_management.*'])->where('region_id',$data['wilaya_id'])->where('is_oman',0)->first();*/
            

                   
        if (!empty($storeData)) {
            //$request->refrence_id
            $packageid = $storeData['s_packageid'];
            $username = $storeData['s_username'];
            $refid = '';
            //$storeid = $storeData['s_id'];
            $d = date('Y-m-d');
            $t = date('H:i:s');
            $regionName ='';
                
            /* $collectionData = DB::table('collection')->where('collection.store_id',$username)->where('collection.co_id',$refid)->first();
             //r_region
             $regionData = DB::table('regions')->where('re_id',$request->region_id)->first();

                 if(!empty($region)){
                     $regionName = $regionData['re_name'];
                 }
                 else{

                     $regionName ='';
                 }
            */

            if (isset($request->type) && $request->type =='new') {
                DB::table('requests')->insert([
                         'store_id'=>$username,
                         'branchid'=>$request->branchid,
                         'r_name'=>$request->customer_name,
                         'r_phone'=>$request->customer_number,
                         'pieces'=>$request->quantity,
                         'weight'=>$request->weight,
                         'wilaya_id'=>$request->wallaya_id,
                         'region_id'=>$request->region_id,
                         'r_region'=>$regionName,
                         'document_type'=>$request->doctype,
                         'r_price'=>$request->order_price,
                         'external_way_bill_number'=>$externalno,
                         'r_date' =>$d,
                         'r_time' =>$t,
                         'r_ship_price'=>$price_val,
                         
                       ]);
            } else {
                DB::table('requests')->insert([
                         'store_id'=>$username,
                         'branchid'=>$request->branchid,
                         'r_name'=>$request->customer_name,
                         'r_phone'=>$request->customer_number,
                         'pieces'=>$request->quantity,
                         'weight'=>$request->weight,
                         'r_wallayah'=>$request->wallaya_id,
                         'r_region_id'=>$request->region_id,
                         'r_region'=>$regionName,
                         'document_type'=>$request->doctype,
                         'r_price'=>$request->order_price,
                         'external_way_bill_number'=>$externalno,
                         'r_date' =>$d,
                         'r_time' =>$t,
                         'r_ship_price'=>$price_val,
                         
                       ]);
            }
                

            if (!empty($collectionData)) {
                                                  
                        
               //        exit;
            }
                    
            
 
                             
            $recId = DB::getPdo()->lastInsertId();
        } else {
            return response(['errors'=>'Error Store code does not exist'], 422);
        }

        $result = DB::Table('requests')->select('r_id as orderid', 'branchid', 'store_id', 'weight', 'r_name', 'r_phone', 'pieces', 'weight')->where('r_id', $recId)->get();
        $response = ['data' =>'A'.$recId];
        return response($response, 200);
    }

    
    public function wilayalist()
    {

        //	echo "<pre>";
        //	echo "test";
        //	exit;
        $result = DB::table('wilaya')->get();
        $response = ['data' => $result];
        return response($response, 200);
    }


    public function wilayalistUpdated()
    {

        //	echo "<pre>";
        //	echo "test";
        //	exit;
        $proid ='';
        if (isset($_GET['province_id'])) {
            $prid = $_GET['province_id'];
        }

        if ($proid!="") {
            $result = DB::table('wilaya_updated')->where('wilaya_updated.parent_id', $proid)->get();
        } else {
            $result = DB::table('wilaya_updated')->get();
        }
        $response = ['data' => $result];
        return response($response, 200);
    }


    public function updatedRegionList(Request $request)
    {
        $validator = Validator::make($request->all(), [
                'wilaya_id' => 'required'
            ]);

        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }

        $wid = $request->wilaya_id;
        // echo "asda";

        //  exit;
        //leftjoin
        $regionsData = DB::table('regions_updated')->where('regions_updated.re_walayah', $wid)->get();



        $response = ['data' => $regionsData];
        return response($response, 200);
    }
    
    public function countriesList()
    {
        $result = DB::table('countries')->get();
        $response = ['data' => $result];
        return response($response, 200);
    }

    public function logout(Request $request)
    {
        $token = $request->user()->token();
        $token->revoke();
        $response = ['message' => 'You have been successfully logged out!'];
        return response($response, 200);
    }
    
    public function regionlistByWilaya(Request $request)
    {
        $validator = Validator::make($request->all(), [
                'wilaya_id' => 'required'
            ]);

        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }

        //leftjoin
        $regionsData = DB::table('regions')->join('wilaya', 'wilaya.id', '=', 'regions.re_walayah')->leftjoin('region_zone_management', 'region_zone_management.region_id', '=', 'regions.re_id')->where('regions.re_walayah', $request['wilaya_id'])->get();



        $response = ['data' => $regionsData];
        return response($response, 200);
    }
    
    public function getPriceByZone($zoneid, $pacakgeid, $doctype, $weight)
    {
        /*
            $this->db->select('price_val')
                        ->from('package_zones')
                        ->where('package_id')->is('=', $pkid)->where('doc_type')->is('=',$doctype)->where('zone_id')->is('=',$rData['zone_id'])
                        ->where('kg_val')->is('=',$weight)
                        ->execute();
                    if($this->db->num_rows() > 0){
                        $output = $this->db->doFetch();
                    }
        */

        $ordersData = DB::table('package_zones')->where('package_id', $pacakgeid)->where('zone_id', $zoneid)->where('doc_type', $doctype)->where('kg_val', $weight)->first();
        return $ordersData->price_val;
    }
    
    public function getOrderLog3()
    {
        $bill_type = substr($_POST['bill_id'], 0, 1);
        $bill_id = $_POST['bill_id'];
        //exit;
        if ($bill_type =='P') {
            $newbill = substr($_POST['bill_id'], 1);
            $ordersData = DB::table('requests')->leftjoin('wilaya', 'wilaya.id', '=', 'requests.r_wallayah')->leftjoin('regions', 'regions.re_id', '=', 'requests.r_region_id')->join('pre_invoice_map', 'pre_invoice_map.actual_id', '=', 'requests.r_id')->join('login', 'login.s_username', '=', 'requests.store_id')->where('pre_invoice_map.pid', $newbill)->first();
            //print_r($ordersData);
            //exit;
            if (!empty($ordersData)) {
                $newbill = $ordersData->r_id;
            } else {
                $newbill = 0;
            }
        } else {
            $newbill = substr($_POST['bill_id'], 1);
            $newbill = $newbill;
        }
   
        //$ordersData->r_id;
        $logs = $this->viewLogs($newbill);
        
                
        $response = ['data' => $logs];
        return response($response, 200);
    }


    public function viewLogs($orderid)
    {
        $response = $this->getLogsFormatted($orderid, 1, 0, 1);
        return $response;
    }
    public function getLogsFormatted($id, $parent_type, $publicOnly = 0, $viewer_userid = 0)
    {
        //echo "test";
        //	exit;
        $logs_b = $this->getLogs($id, $parent_type, $publicOnly, $viewer_userid);
        //exit;
        //$logs = (array) $logs_b;
        $logs = (array) $logs_b;
        //echo "<pre>";
        //print_r($logs['*items']);
        //exit;
        $output = '<div class="card card-body border-top-warning" dir="ltr">';
        if (count($logs) > 0) {
            $output .= '<div class="list-feed list-feed-time">';
            foreach ($logs as $k=>$r) {
                foreach ($r as $r2) {
                    //$row = (array) $r2;
                    
                    $row = (array) $r2;
                    //	print_r($row);
                    
                    //exit;
                    $output .= '<div class="list-feed-item">
                                <span class="feed-time text-muted font-size-sm">'.date('H:i', strtotime($row['create_time'])).'</span>
                                <span class="text-muted mr-2">'.date('Y-m-d', strtotime($row['create_time'])).'</span>
                                '.$row['phrase'].' - <span class="text-muted"><strong>By</strong> '.$row['c_username'].', <strong>Branch</strong> '.$row['name_en'].'</span>
                            </div>';
                }
            }
            $output .= '</div>';
        } else {
            $output .= '<div class="text-center">No logs available</div>';
        }
        $output .= '</div>';
        return $output;
    }
    public function getLogs($id, $parent_type, $publicOnly, $viewer_userid)
    {
        $ordersData = DB::table('change_log')->join('change_phrase', 'change_phrase.cpid', '=', 'change_log.cpid')->leftjoin('cpanel', 'cpanel.c_id', '=', 'change_log.cpid')->join('login', 'login.s_id', '=', 'change_log.userid')->join('branch', 'branch.branchid', '=', 'change_log.branchid')->where('parent_type', $parent_type)->where('parentid', $id)->where('parentid', $id)->where('cl_status', '>', 0)->orderByDesc('change_log.create_time')->get();
        return $ordersData;
    }
    
    public function getordersByrefrence()
    {
        $validator = Validator::make($request->all(), [
                'refrence_id' => 'required'
            ]);

        if ($validator->fails()) {
            return response(['errors'=>$validator->errors()->all()], 422);
        }

        $refrence_id = mysql_real_escape_string($_POST['refrence_id']);
        $ordersData = DB::table('requests')->where('requests.co_id', $refrence_id)->get();



        $response = ['data' => $ordersData];
        return response($response, 200);
    }










    // --------------------------------------------------------------------------------------------------------------



    // Store Apis


    public function createPickup(Request $request)
    {


        try {

			


            DB::table('collection')->insert([
				"store_id"=>$request->store_username,
                'branchid'=>$request->branch_id,
                "periodid"=>$request->period_id,
				"create_userid"=>$request->create_user_id,
                'store_id'=>$request->username,
				"wallayah_id"=>$request->wilaya_id,
				"region_id"=>$request->area_id,
				"is_completed"=>$request->is_completed,
				"co_quantity"=>$request->quantity,
				"co_date"=>$request->collection_date,
				"co_time"=>$request->collection_time,
				"collected_cash"=>$request->collected_cash,
				"driver_collected"=>$request->driver_collected,
				"admin_confrimed"=>$request->admin_confirmed,
				"driver_accepted"=>$request->driver_accepted,
				"pickup_type"=>$request->pickup_type,
				"reference_type"=>$request->reference_type,
              ]);


			  return response()->json([
				  "status"=>"success",
				  "message"=>"Collection created in old system"
			  ]);


        } catch (\Exception $e) {
            return response()->json([
				"status"=>"error",
                "message"=>$e->getMessage()
            ]);
        }
    }


    
    public function getStoreByMobile(Request $request)
    {

		try {

			$mobile = $request->mobile;

			$store = DB::table('login')->where('s_mobile', $mobile)->first();

			return response()->json([
				"status"=>"success",
				"data"=>[
					"store"=>$store
				]
			]);
		} catch (\Exception $e) {
			return response()->json([
				"status"=>"error",
                "message"=>$e->getMessage()
            ]);
		}

      
    }






    // --------------------------------------------------------------------------------------------------------------
}
