<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Artisan;

Route::group(['prefix' => 'v1'], function () {
    Route::middleware('auth:api')->get('/user', function (Request $request) {
        return $request->user();
    });
});

/**
 * group api v1 routes under
 * Api\v1 directory in controllers
 */
Route::group(['prefix' => 'v1', 'namespace' => 'Api\v1'], function () {
    Route::apiResource('/posts', 'PostController');

    Route::group(['prefix' => 'posts'], function () {
        Route::apiResource('{post}/comments', 'CommentController');
    });
});

Route::get("test", function () {
    // return response()->json(['message' => 'Hello World']);

    Artisan::call('cache:clear');
    Artisan::call('config:clear');
    Artisan::call('route:clear');
    Artisan::call('view:clear');
    Artisan::call('clear-compiled');
    Artisan::call('optimize:clear');

    return "d";
});

Route::group(['prefix' => 'v1'], function () {
    // ...
    Route::post('/login', 'Auth\ApiAuthControllerTest1@login')->name('login.api');
    //    Route::get('/wilayalist', 'Auth\ApiAuthControllerTest1@wilayalist')->name('wilayalist.api');
    Route::post('/register', 'Auth\ApiAuthControllerTest1@register')->name('register.api');
    Route::post('/logout', 'Auth\ApiAuthControllerTest1@logout')->name('logout.api');
    Route::post('/regions', 'Auth\ApiAuthControllerTest1@regionlistByWilaya')->name('regions.api');
    Route::get('/wilaya', 'Auth\ApiAuthControllerTest1@wilayaList')->name('wilaya.api');
    Route::get('/countries', 'Auth\ApiAuthControllerTest1@countriesList')->name('countries.api');
    Route::post('/cities', 'Auth\ApiAuthControllerTest1@citilistByCountry')->name('cities.api');
    Route::post('/calculatePrice', 'Auth\ApiAuthControllerTest1@calculatePrice')->name('calculatePrice.api');
    Route::get('/download_order2', 'Auth\ApiAuthControllerTest1@printDalileeOrders2')->name('download_order2.api');

    Route::post('/calculatePriceUpdated', 'Auth\ApiAuthControllerTest1@calculatePriceUpdated')->name('calculatePriceUpdated.api');

    Route::get("test", function () {
        // return response()->json(['message' => 'Hello World']);

        Artisan::call('cache:clear');
        Artisan::call('config:clear');
        Artisan::call('route:clear');
        Artisan::call('view:clear');
        Artisan::call('clear-compiled');
        Artisan::call('optimize:clear');
    });

    Route::post('/getOrderLog', 'Auth\ApiAuthControllerTest1@getOrderLogNew')->name('getOrderLog.api');
    Route::post('/getOrderStatus', 'Auth\ApiAuthControllerTest1@getOrderStatus')->name('getOrderStatus.api');

    Route::post('/addordertasheel', 'Auth\ApiAuthControllerTest1@addordertasheel')->name('addordertasheel.api');
    Route::post('/addorderdalileeswaq', 'Auth\ApiAuthControllerTest1@addorderdalileeswaq')->name('addorderdalileeswaq.api');
    Route::post('/getstoreData', 'Auth\ApiAuthControllerTest1@getstoreData')->name('getstoreData.api');


    Route::post('/cancel_order', 'Auth\ApiAuthControllerTest1@cancel_order')->name('cancel_order.api');


    Route::post('/download_order', 'Auth\ApiAuthControllerTest1@printDalileeOrders')->name('download_order.api');

    Route::post('/getstoreData', 'Auth\ApiAuthControllerTest1@getstoreData')->name('getstoreData.api');

    Route::post('/getOrderData', 'Auth\ApiAuthControllerTest1@getOrderData')->name('getOrderData.api');

    Route::post('/verify_customer', 'Auth\ApiAuthControllerTest1@verifyDalileeCustomer')->name('verify_customer.api');
});

Route::prefix('v1')->group(function () {

    Route::middleware(['auth:api'])->group(function () {

        Route::post('/viewStoreData', 'Auth\ApiAuthControllerTest1@viewStoreData')->name('viewStoreData.api');

        // These will be prefixed with "manager" and assigned the "manager_auth" middleware
        Route::post('/signupTrader', 'Auth\ApiAuthControllerTest1@signupTrader')->name('signupTrader.api');
        //Route::get('/wilayalist', 'Auth\ApiAuthControllerTest1@signupTrader')->name('wilayalist.api');
        Route::post('/regionlist', 'Auth\ApiAuthControllerTest1@regionlistByWilaya')->name('regionlist.api');
        Route::get('/wilayalist', 'Auth\ApiAuthControllerTest1@wilayaList')->name('wilayalist.api');

        Route::get('/wilayalistUpdated', 'Auth\ApiAuthControllerTest1@wilayalistUpdated')->name('wilayalistUpdated.api');

        Route::post('/updatedRegionList', 'Auth\ApiAuthControllerTest1@updatedRegionList')->name('updatedRegionList.api');


        Route::post('/addreference', 'Auth\ApiAuthControllerTest1@addref')->name('addreference.api');
        Route::post('/refrenceData', 'Auth\ApiAuthControllerTest1@refrenceDataByID')->name('refrenceData.api');
        Route::post('/addorder', 'Auth\ApiAuthControllerTest1@addorder')->name('addorder.api');
        Route::post('/addordernew', 'Auth\ApiAuthControllerTest1@addordernew')->name('addordernew.api');
        Route::post('/addreverseorder', 'Auth\ApiAuthControllerTest1@addreverseorder')->name('addreverseorder.api');

        Route::post('/verifyStore', 'Auth\ApiAuthControllerTest1@verifyStore')->name('verifyStore.api');
        //Route::get('/getordersByrefrence', 'Auth\ApiAuthControllerTest1@getorderByrefrence')->name('getorderByrefrence.api');
        Route::post('/getordersByrefrence', 'Auth\ApiAuthControllerTest1@getorderByrefrence')->name('getordersByrefrence.api');
        //Route::get('/getOrderLog', 'Auth\ApiAuthControllerTest1@getOrderLog')->name('getOrderLog.api');	
    });

    // These will just be prefixed with "manager"
});



// Store apis to connect with shaheen



Route::prefix('store')->group(function () {

    Route::post("createPickup", 'Auth\ApiAuthControllerTest1@createPickup');


    Route::post("getStoreByMobile", 'Auth\ApiAuthControllerTest1@getStoreByMobile');

    // 
});


Route::get("/branch", function () {

    $branches = DB::table('branch')->get();
    return response()->json(['message' => 'Hello World', 'branches' => $branches]);
});


/*

    Route::get("test", function () {

       $ordersArr=[
        "99596942",
        
       
       ];

        $collArr = [
           
            "834541",
            "834542",
            "834543",
            "834544",





        ];

        $orderArrSub = array_chunk($ordersArr, 10);



        foreach($ordersArr as $order){



          $r_id=  DB::table("requests")->insertGetId([
                "branchid"=>1,
                "r_name"=>"test",
                "r_phone"=>"test",
                "r_price"=>"0",
                "r_time"=>"20:00:00",
                "r_ship_price"=>"0",
                "store_id"=>"test",
                "driver_id"=>"1020"
            ]);

            DB::table('pre_invoice_map')->where("pid",$order)->update(["actual_id"=>$r_id]);

        }




        foreach ($collArr as $ind => $coll) {


            $reqs = DB::table('requests as rq')
                ->join("pre_invoice_map as pim", "pim.actual_id", "=", "rq.r_id")
                ->whereIn("pim.pid", $orderArrSub[$ind])
                ->select("rq.r_id")
                ->get()
                ->pluck("r_id")
                ->toArray();




            $r =  DB::table("requests as rq")
                ->whereIn("rq.r_id", $reqs)
                ->update(["rq.co_id" => $coll]);
        }
    });

    test2_ test

    */
Route::prefix('shaheen-api')->group(function () {

    Route::post("createReference", 'Api\ShaheenApis\ShaheenApisController@createReference');

    Route::post("createReference2", 'Api\ShaheenApis\ShaheenApisController@createReference2');

    Route::post("createStore", 'Api\ShaheenApis\ShaheenApisController@createStore');

    Route::post("createDriver", 'Api\ShaheenApis\ShaheenApisController@createDriver');

    Route::post("assignDriverToCollection", 'Api\ShaheenApis\ShaheenApisController@assignDriverToCollection');


    Route::post("createRunsheet", 'Api\ShaheenApis\ShaheenApisController@createRunsheet');


    Route::post("createSendsheet", 'Api\ShaheenApis\ShaheenApisController@createSendsheet');

    Route::post("createReceivesheet", 'Api\ShaheenApis\ShaheenApisController@createReceivesheet');

    Route::post("updateCOP", 'Api\ShaheenApis\ShaheenApisController@updateCOP');

    Route::post("updateOrderCOD", 'Api\ShaheenApis\ShaheenApisController@updateOrderCOD');


    Route::post("LogSheetOrderConfirm", 'Api\ShaheenApis\ShaheenApisController@LogSheetOrderConfirm');


    Route::post("LogSheetConfirm", 'Api\ShaheenApis\ShaheenApisController@LogSheetConfirm');


    Route::post("dataEntryLogsheet", 'Api\ShaheenApis\ShaheenApisController@dataEntryLogsheet');


    Route::post("debreifingChangeOrderStatus", 'Api\ShaheenApis\ShaheenApisController@debreifingChangeOrderStatus');


    Route::post("debreifingConfirmRunsheets", 'Api\ShaheenApis\ShaheenApisController@debreifingConfirmRunsheets');

    // as
    // Route::post("cashierClose",'Api\ShaheenApis\ShaheenApisController@cashierClose');


    Route::post("cashierClose", 'Api\ShaheenApis\ShaheenApisController@cashierClose');


    Route::post("dataEntryNextOrder", 'Api\ShaheenApis\ShaheenApisController@dataEntryNextOrder');


    Route::post("dataEntryUpdateCollection", 'Api\ShaheenApis\ShaheenApisController@dataEntryUpdateCollection');



    Route::post("getOrdersPickup", 'Api\ShaheenApis\ShaheenApisController@getOrdersPickup');


    Route::post("updateOrdersPickup", 'Api\ShaheenApis\ShaheenApisController@updateOrdersPickup');


    Route::post("getLastPid", 'Api\ShaheenApis\ShaheenApisController@getLastPid');


    // 
    Route::post("getCollections", 'Api\ShaheenApis\ShaheenApisController@getCollections');


    Route::post("getPreInvoies", 'Api\ShaheenApis\ShaheenApisController@getPreInvoies');


    Route::post("updateIsSynced", 'Api\ShaheenApis\ShaheenApisController@updateIsSynced');

    Route::post("updateIsSyncedRequest", 'Api\ShaheenApis\ShaheenApisController@updateIsSyncedRequest');

    Route::post("updateIsSyncedCollection", 'Api\ShaheenApis\ShaheenApisController@updateIsSyncedCollection');


    Route::post("updateIsDataEntry", 'Api\ShaheenApis\ShaheenApisController@updateIsDataEntry');


    Route::post("updateOrder", 'Api\ShaheenApis\ShaheenApisController@updateOrder');

    Route::post("dataEntryOrders", 'Api\ShaheenApis\ShaheenApisController@dataEntryOrders');


    Route::post("getRemaingingOrdersInRunsheets", 'Api\ShaheenApis\ShaheenApisController@getRemaingingOrdersInRunsheets');


    Route::post("getOrdersForReport", 'Api\ShaheenApis\ShaheenApisController@getOrdersForReport');

    Route::post("getExternalOrders", 'Api\ShaheenApis\ShaheenApisController@getExternalOrders');


    Route::post("addOrdersOfflineDriverPickup", 'Api\ShaheenApis\ShaheenApisController@addOrdersOfflineDriverPickup');

    Route::post("getStore", 'Api\ShaheenApis\ShaheenApisController@getStore');
    Route::post("getStoreByEmail", 'Api\ShaheenApis\ShaheenApisController@getStoreByEmail');

    Route::post("getOrderData", 'Api\ShaheenApis\ShaheenApisController@getOrderData');

    // shipper app api starts
    Route::post("getStoresOrdersCount", 'Api\ShaheenApis\ShaheenApisController@getStoresOrdersCount');
    Route::post("getStoresOrders", 'Api\ShaheenApis\ShaheenApisController@getStoresOrders');

    Route::post("update_shipper_comments", 'Api\ShaheenApis\ShaheenApisController@updateShipperComments');
    
    Route::post("storeFinanceDashboard", 'Api\ShaheenApis\ShaheenApisController@storeFinanceDashboard');
    Route::post("storeFinanceOrders", 'Api\ShaheenApis\ShaheenApisController@storeFinanceOrders');

    Route::post("shipmentsInOut", 'Api\ShaheenApis\ShaheenApisController@shipmentsInOut');

    Route::post("traderPickup", 'Api\ShaheenApis\ShaheenApisController@traderPickup');

    Route::post("collectionOrders", 'Api\ShaheenApis\ShaheenApisController@collectionOrders');

    Route::post("openFinance", 'Api\ShaheenApis\ShaheenApisController@openFinance');

    Route::post("closeFinance", 'Api\ShaheenApis\ShaheenApisController@closeFinance');

    // shipeer app api ends
});
